Logo AND Algorithmique Numérique Distribuée

Public GIT Repository
sonar don't like comments ending with ';'
[simgrid.git] / src / smpi / smpirun.in
1 #!/usr/bin/env sh
2
3 # Copyright (c) 2007-2016, The SimGrid Team. All rights reserved.
4
5 # This program is free software; you can redistribute it and/or modify it
6 # under the terms of the license (GNU LGPL) which comes with this package.
7
8 @CMAKE_SMPI_COMMAND@
9
10 SIMGRID_VERSION="@SIMGRID_VERSION_STRING@"
11 SIMGRID_GITHASH="@SIMGRID_GITHASH@"
12
13 DEFAULT_LOOPBACK_BANDWIDTH="498000000Bps"
14 DEFAULT_LOOPBACK_LATENCY="0.000004s"
15 DEFAULT_NETWORK_BANDWIDTH="$((26 * 1024 * 1024))Bps"
16 DEFAULT_NETWORK_LATENCY="0.000005s"
17 DEFAULT_NUMPROCS="4"
18 DEFAULT_SPEED="100flops"
19
20 LOOPBACK_BANDWIDTH="${DEFAULT_LOOPBACK_BANDWIDTH}"
21 LOOPBACK_LATENCY="${DEFAULT_LOOPBACK_LATENCY}"
22 NETWORK_BANDWIDTH="${DEFAULT_NETWORK_BANDWIDTH}"
23 NETWORK_LATENCY="${DEFAULT_NETWORK_LATENCY}"
24 SPEED="${DEFAULT_SPEED}"
25
26 PRIVATIZE="--cfg=smpi/privatization:@HAVE_PRIVATIZATION@"
27
28 SIMOPTS="--cfg=surf/precision:1e-9 --cfg=network/model:SMPI"
29
30 #usage to print the way this script should be called
31 usage () {
32     cat <<EOF
33 Usage: $0 [OPTIONS] -platform <xmldesc> -hostfile <hostfile> program [program-options]
34 Options:
35   -keep-temps                # don't remove the generated files after execution
36   -wrapper <command>         # use command to run the program (e.g. "valgrind" or "gdb --args")
37   -map                       # display the machine on which each process rank is mapped
38   -np <numprocs>             # use that amount of processes from the hostfile.
39                              # By default, all processes of the hostfile are used.
40   -no-privatize              # Disable the globals privatization, that is activated by default
41   -trace-ti                  # activate time independant tracing (for replay, default in smpi_simgrid.txt)
42   -trace                     # activate tracing (Paje, default in smpi_simgrid.trace)
43   -trace-comment <comment>   # put a comment on the top of the trace file
44   -trace-comment-file <file> # put file contents on the top of the trace file as comment
45   -trace-grouped             # group MPI processes by location
46   -trace-resource            # trace resource utilization
47   -trace-file <tracefile>    # name of the tracefile (simgrid_smpi.trace)
48   -ext <value>               # additional parameter (reserved)
49
50   -version                   # Displays the SimGrid version (human readable)
51   -git-version               # Displays the git hash of SimGrid
52
53 or (deprecated usage):
54   $0 [-keep-temps] [-np <numprocs>] [-bandwidth <bytes/sec>] [-latency <secs>] program [program-options]
55
56 EOF
57 }
58
59 #check if we have at least one parameter
60 if [ $# -eq 0 ]
61 then
62     usage
63     exit
64 fi
65
66 EXTOPT=""
67 WRAPPER=""
68 HOSTFILE=""
69 HOSTFILETMP=0
70 MAPOPT=0
71 REPLAY=0
72
73 unset pid
74
75 trapped_signals="HUP INT QUIT ILL ABRT SEGV FPE ALRM TERM USR1 USR2 BUS"
76
77 die () {
78     printf '[%s] ** error: %s. Aborting.\n' "$(basename $0)" "$*" >&2
79     exit 1
80 }
81
82 smpirun_cleanup()
83 {
84   if [ -z "${KEEP}" ] ; then
85       if [ -z "${PLATFORM}" -a -n "$PLATFORMTMP" ]; then
86         rm -f ${PLATFORMTMP}
87         PLATFORMTMP=""
88       fi
89       if [ ${HOSTFILETMP} = 1 -a -n "$HOSTFILE" ] ; then
90           rm -f ${HOSTFILE}
91           HOSTFILE=""
92       fi
93       if [ ${UNROLLEDHOSTFILETMP} = 1 -a -n "$UNROLLEDHOSTFILE" ] ; then
94           rm -f ${UNROLLEDHOSTFILE}
95           UNROLLEDHOSTFILE=""
96       fi
97       if [ -n ${APPLICATIONTMP} ]; then
98         rm -f ${APPLICATIONTMP}
99         APPLICATIONTMP=""
100       fi
101   fi
102 }
103
104 smpirun_trap() {
105   local sig
106   sig="$1"
107
108   # Cleanup and kill the child process:
109   smpirun_cleanup
110   if ! [ -z "$pid" ]; then
111     kill -TERM $pid
112   fi
113   unset pid
114
115   # Raise the same signal again (remove the traps first):
116   trap - $trapped_signals
117   kill -$sig $$
118
119   # This should never happen:
120   kill -ABRT $$
121   kill -TERM $$
122 }
123
124 for s in $trapped_signals; do
125   trap "smpirun_trap $s" $s
126 done
127
128 while true; do
129     case "$1" in
130         "-np" | "-n")
131             NUMPROCS="$2"
132             shift 2
133             ;;
134         "-bandwidth")
135             NETWORK_BANDWIDTH="$2"
136             shift 2
137             ;;
138         "-latency")
139             NETWORK_LATENCY="$2"
140             shift 2
141             ;;
142         "-platform")
143             PLATFORM="$2"
144             if [ ! -f "${PLATFORM}" ]; then
145                 die "the file '${PLATFORM}' does not exist"
146             fi
147             shift 2
148             ;;
149         "-hostfile" | "-machinefile")
150             HOSTFILE="$2"
151             if [ ! -f "${HOSTFILE}" ]; then
152                 die "the file '${HOSTFILE}' does not exist"
153             fi
154             shift 2
155             ;;
156         "-ext")
157             EXTOPT="$2"
158             shift 2
159             ;;
160         "-no-privatize")
161             PRIVATIZE=""
162             shift 1
163             ;;
164         "-map")
165             MAPOPT=1
166             shift 1
167             ;;
168         "-trace")
169             TRACE_ACTIVE="true"
170             shift 1
171             ;;
172         "-trace-ti")
173             TRACE_ACTIVE="true"
174             TRACE_TI_ACTIVE="true"
175             shift 1
176             ;;
177         "-trace-comment")
178             TRACE_COMMENT="$2"
179             shift 2
180             ;;
181         "-trace-comment-file")
182             TRACE_COMMENT_FILE="$2"
183             shift 2
184             ;;
185         "-trace-file")
186             TRACE_FILENAME="$2"
187             shift 2
188             ;;
189         "-trace-grouped")
190             TRACE_GROUPED="true"
191             shift 1
192             ;;
193         "-trace-resource")
194             TRACE_RESOURCE="true"
195             shift 1
196             ;;
197         "-keep-temps")
198             KEEP="true"
199             SIMOPTS="$SIMOPTS --cfg=smpi/keep-temps:yes"
200             shift 1
201             ;;
202         "-wrapper")
203             WRAPPER="$2"
204             shift 2
205             ;;
206         "-help" | "--help" | "-h")
207             usage
208             exit 0
209             ;;
210         "-version" | "--version" | "-v")
211             printf '%b\n' "$SIMGRID_VERSION"
212             exit 0
213             ;;
214         "-git-version" | "--git-version")
215             printf '%b\n' "$SIMGRID_GITHASH"
216             exit 0
217             ;;
218         "--cfg="*|"--log="*)
219             for OPT in ${1#*=}
220             do
221                 SIMOPTS="$SIMOPTS ${1%%=*}=$OPT"
222             done
223             shift 1
224             ;;
225         "-foreground")
226             # Nothing to do, compatibility.
227             shift 1
228             ;;
229         *)
230             break
231             ;;
232     esac
233 done
234
235 # check if we still have at least one parameter beyond options
236 if [ $# -eq 0 ]
237 then
238     echo "Error: no program to execute!"
239     usage
240     exit
241 fi
242
243 EXEC="$1"
244 shift
245
246 # steel --cfg and --logs options
247 while [ $# -gt 0 ]; do
248     case "$1" in
249         "--cfg="*|"--log="*)
250             for OPT in ${1#*=}
251             do
252                 SIMOPTS="$SIMOPTS ${1%%=*}=$OPT"
253             done
254             shift 1
255             ;;
256         *)
257             PROC_ARGS="${PROC_ARGS:+$PROC_ARGS }$1"
258             shift      
259             ;;
260     esac
261 done
262
263 if [ -z "${HOSTFILE}" ] && [ -z "${PLATFORM}" ] ; then
264     echo "No hostfile nor platform specified."
265     usage
266     exit 1
267 fi
268
269 if [ -z "${HOSTFILE}" ] ; then
270     HOSTFILETMP=1
271     HOSTFILE="$(mktemp smpitmp-hostfXXXXXX)"
272     perl -ne 'print "$1\n" if /.*<host.*?id="(.*?)".*?\/>.*/' ${PLATFORM} > ${HOSTFILE}
273     perl -ne 'if (/.*<cluster.*?prefix="(.*?)".*?radical="(.*?)".*?suffix="(.*?)".*/) { 
274                 my ($pre,$rad,$post)=($1,$2,$3); 
275                 for my $elm (split(",",$rad)) { 
276                   if ($elm=~/^([^-]*?)-([^-]*)$/) { 
277                      for (my $i=$1; $i<=$2;$i++) { 
278                         print "$pre$i$post\n"; 
279                      }
280                   } else {
281                      print "$pre$elm$post\n";
282                   }
283                 }
284               } elsif (/<cluster/) {
285             die ("Unparsable cluster tag. smpirun uses a primitive regular expression to parse cluster tags. Either provide a hostfile yourself or give the attributes prefix, radical and suffix IN THAT ORDER and ON THE SAME LINE as the opening tag (<cluster)");
286               }' ${PLATFORM} >> ${HOSTFILE}
287 fi
288 UNROLLEDHOSTFILETMP=0
289
290 #parse if our lines are terminated by :num_process
291 multiple_processes=$(grep -c ":" $HOSTFILE)
292 if [ "${multiple_processes}" -gt 0 ] ; then
293     UNROLLEDHOSTFILETMP=1
294     UNROLLEDHOSTFILE="$(mktemp smpitmp-hostfXXXXXX)"
295     perl -ne ' do{ for ( 1 .. $2 ) { print "$1\n" } } if /(.*?):(\d+).*/'  ${HOSTFILE}  > ${UNROLLEDHOSTFILE}
296     if [ ${HOSTFILETMP} = 1 ] ; then
297         rm ${HOSTFILE}
298         HOSTFILETMP=0
299     fi
300     HOSTFILE=$UNROLLEDHOSTFILE
301 fi
302
303 # Don't use wc -l to compute it to avoid issues with trailing \n at EOF
304 hostfile_procs=$(grep -c "[a-zA-Z0-9]" $HOSTFILE)
305 if [ ${hostfile_procs} = 0 ] ; then
306     die "the hostfile '${HOSTFILE}' is empty"
307 fi
308
309 if [ -z "${NUMPROCS}" ] ; then
310     # Use the amount of processes in the hostfile as default value for the -np parameter
311     NUMPROCS=$hostfile_procs
312 fi
313
314 if [ ${NUMPROCS} -gt ${hostfile_procs} ] ; then
315     echo "You requested to use ${NUMPROCS} ranks, but there is only ${hostfile_procs} processes in your hostfile..." >&2
316 fi
317
318 ##-------------------------------- DEFAULT or SPECIFIED PLATFORM --------------------------------------
319 if [ -z "${PLATFORM}" ]; then
320     PLATFORMTMP="$(mktemp smpitmp-platfXXXXXX)"
321
322     cat > ${PLATFORMTMP} <<PLATFORMHEAD
323 <?xml version='1.0'?>
324 <!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid/simgrid.dtd">
325 <platform version="4.1">
326 <zone id="AS0" routing="Full">
327 PLATFORMHEAD
328
329     i=${NUMPROCS}
330     while [ $i -gt 0 ]; do
331         echo "  <host id=\"host$i\" speed=\"${SPEED}\"/>" >> ${PLATFORMTMP}
332         echo "  <link id=\"loop$i\" bandwidth=\"${LOOPBACK_BANDWIDTH}\" latency=\"${LOOPBACK_LATENCY}\"/>" >> ${PLATFORMTMP}
333         echo "  <link id=\"link$i\" bandwidth=\"${NETWORK_BANDWIDTH}\" latency=\"${NETWORK_LATENCY}\"/>" >> ${PLATFORMTMP}
334         i=$((i - 1))
335     done
336
337     i=${NUMPROCS}
338     while [ $i -gt 0 ]; do
339         j=${NUMPROCS}
340         while [ $j -gt 0 ]; do
341             if [ $i -eq $j ]; then
342                 echo "  <route src=\"host$i\" dst=\"host$j\"><link_ctn id=\"loop$i\"/></route>" >> ${PLATFORMTMP}
343             else
344                 echo "  <route src=\"host$i\" dst=\"host$j\"><link_ctn id=\"link$i\"/><link_ctn id=\"link$j\"/></route>" >> ${PLATFORMTMP}
345             fi
346             j=$((j - 1))
347         done
348         i=$((i - 1))
349     done
350
351     cat >> ${PLATFORMTMP} <<PLATFORMFOOT
352 </zone>
353 </platform>
354 PLATFORMFOOT
355
356 else
357     PLATFORMTMP=${PLATFORM}
358 fi
359 ##-------------------------------- end DEFAULT or SPECIFIED PLATFORM --------------------------------------
360 ##-------------------------------- DEFAULT APPLICATION --------------------------------------
361 APPLICATIONTMP="$(mktemp smpitmp-appXXXXXX)"
362 #APPLICATIONTMP="app.xml"
363
364 cat > ${APPLICATIONTMP} <<APPLICATIONHEAD
365 <?xml version='1.0'?>
366 <!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid/simgrid.dtd">
367 <platform version="4.1">
368 APPLICATIONHEAD
369
370 ##---- cache hostnames of hostfile---------------
371 if [ -n "${HOSTFILE}" ] && [ -f ${HOSTFILE} ]; then
372     hostnames=$(cat ${HOSTFILE} | tr '\n\r' '  ')
373 fi
374
375 if [ "${EXTOPT}" = "smpi_replay" ]; then
376     APP_TRACES=$PROC_ARGS
377     if [ -n "${APP_TRACES}" ] && [ -f "${APP_TRACES}" ]; then
378         hosttraces=$(cat ${APP_TRACES} | tr '\n\r' '  ' )
379         NUMTRACES=$(cat ${APP_TRACES} | wc -l)
380         REPLAY=1
381     else
382         printf "File not found: %s\n" "${APP_TRACES:-\${APP_TRACES\}}" >&2
383         exit 1
384     fi
385 fi
386
387 ##----------------------------------------------------------
388 ##  generate application.xml with hostnames from hostfile:
389 ##  the name of host_i (1<=i<=p, where -np p) is the line i in hostfile (where -hostfile hostfile), or "host$i" if 
390 ##  hostfile has less than i lines.
391 ##----------------------------------------------------------
392
393 HAVE_SEQ="$(which seq 2>/dev/null)"
394
395 if [ -n "${HAVE_SEQ}" ]; then
396     SEQ=$(${HAVE_SEQ} 0 $(( NUMPROCS - 1)))
397 else
398     cnt=0
399     while [ $cnt -lt ${NUMPROCS} ] ; do
400         SEQ="$SEQ $cnt"
401         cnt=$((cnt + 1));
402     done
403 fi
404
405 set -- $hostnames
406
407 ##---- generate <actor> tags------------------------------
408 #prepare arguments at once
409 for ARG in $PROC_ARGS; do
410   XML_ARGS="${XML_ARGS}""<argument value=\"${ARG}\"/>
411 "
412 done
413
414 for i in ${SEQ}
415 do
416     j=$(( i % hostfile_procs + 1 ))
417     host=$(eval "echo \${$j}")
418
419     ##---- optional display of ranks to actor mapping
420     if [ ${MAPOPT} = 1 ]; then
421       echo "[rank $i] -> $host"
422     fi
423
424     echo "  <actor host=\"${host}\" function=\"$i\"> <!-- function name used only for logging -->
425     <argument value=\"smpirun\"/> <!-- instance -->
426     <argument value=\"$i\"/> <!-- rank -->" >> ${APPLICATIONTMP}
427     if [ ${REPLAY} = 1 ]; then
428         if  [ ${NUMTRACES} -gt 1 ]; then
429             echo "    <argument value=\"$(echo $hosttraces|cut -d' ' -f$j)\"/>" >> ${APPLICATIONTMP}
430         else
431             echo "    <argument value=\"$(echo $hosttraces|cut -d' ' -f1)\"/>" >> ${APPLICATIONTMP}
432         fi
433     else 
434     echo ${XML_ARGS} >> ${APPLICATIONTMP}
435     fi
436     echo "  </actor>" >> ${APPLICATIONTMP}
437 done
438
439 cat >> ${APPLICATIONTMP} <<APPLICATIONFOOT
440 </platform>
441 APPLICATIONFOOT
442 ##-------------------------------- end DEFAULT APPLICATION --------------------------------------
443 ##---------------------- SMPI TRACING OPTIONS ---------------------------------
444 if [ -n "${TRACE_ACTIVE}" ]; then
445     #define trace filename
446     if [ -n "${TRACE_TI_ACTIVE}" ]; then
447         if [ -z "${TRACE_FILENAME}" ]; then
448             TRACE_FILENAME="smpi_simgrid.txt"
449         fi
450         TRACEOPTIONS="--cfg=tracing:yes --cfg=tracing/filename:${TRACE_FILENAME} --cfg=tracing/smpi:yes --cfg=tracing/smpi/format:TI --cfg=tracing/smpi/computing:yes"
451     else
452         if [ -z "${TRACE_FILENAME}" ]; then
453             TRACE_FILENAME="smpi_simgrid.trace"
454         fi
455         TRACEOPTIONS="--cfg=tracing:yes --cfg=tracing/filename:${TRACE_FILENAME} --cfg=tracing/smpi:yes"
456     fi
457
458     if [ -n "${TRACE_COMMENT}" ]; then
459         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment:${TRACE_COMMENT}"
460     fi
461
462     if [ -n "${TRACE_COMMENT_FILE}" ]; then
463         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment-file:${TRACE_COMMENT_FILE}"
464     fi
465
466     if [ -n "${TRACE_GROUPED}" ]; then
467         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/smpi/group:yes"
468     fi
469
470     if [ -n "${TRACE_RESOURCE}" ]; then
471         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/categorized:yes --cfg=tracing/uncategorized:yes"
472     fi
473 fi
474 ##---------------------- end SMPI TRACING OPTIONS ---------------------------------
475
476 export SMPI_GLOBAL_SIZE=${NUMPROCS}
477 if [ -n "${KEEP}" ] ; then
478     echo ${EXEC} ${PRIVATIZE} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
479     if [ ${HOSTFILETMP} = 1 ] ; then
480         echo "Generated hostfile ${HOSTFILE} kept."
481     fi
482     if [ ${UNROLLEDHOSTFILETMP} = 1 ] ; then
483         echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} kept." 
484     fi
485 fi
486
487 # Execute the process
488 #
489 # The shell still need to be alive for the duration in order to do some cleanup after the process.
490 #
491 # We are going through great lengths in order to both keep stdin and be able to handle signals:
492 #
493 # * The job is launched in the background in order to be able to handle signals.
494 #
495 # * The FD 3 is used to temporarily store FD 1. This is because the shell connects FD 1 to /dev/null when the command
496 #   is launched in the background: this can be overriden in bash but not in standard bourne shell.
497 exec 3<&0
498 ${WRAPPER} "@SMPIMAIN@" ${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP} <&3 3>&- &
499 pid=$!
500 exec 3>&-
501 wait $pid
502 status=$?
503 pid=""
504
505 # Keep temporary files on failures to help debugging
506 #
507 if [ ${status} -ne 0 ] ; then
508     if [ -z "${KEEP}" ]; then
509         echo ${EXEC} ${PRIVATIZE} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
510         if [ ${HOSTFILETMP} = 1 ] ; then
511             echo "Generated hostfile ${HOSTFILE} kept."
512         fi
513         if [ ${UNROLLEDHOSTFILETMP} = 1 ] ; then
514             echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} kept."
515         fi
516     fi
517     echo "Execution failed with code ${status}."
518     KEEP=true
519 fi
520
521 smpirun_cleanup
522
523 exit $status